unit rw_utility_various;

interface

type
  TDateTimeDLL = packed record
    year,month,day,hour,min,sec,msec: smallint;
  end;

function  B_and(a,b: integer): integer; stdcall;
function  B_or(a,b: integer): integer; stdcall;
function  B_xor(a,b: integer): integer; stdcall;
function  Color2MIColor(A: integer): integer; stdcall;
function  Currency: pansichar; stdcall;
function  GetTickCount: int64; stdcall;
function  MD5(filename: pansichar): pansichar; stdcall;
function  MeasureUnit: smallint; stdcall;
procedure Mkdir(foldername: pansichar); stdcall;
function  Random: double; stdcall;
function  RandomRange(a: integer): integer; stdcall;
procedure Randomize; stdcall;
procedure sleep(a: integer); stdcall;
function  utf8len(s: pansichar): integer; stdcall;
function  FileSize(filename: pansichar): Int64; stdcall;
function  GetLastWriteTime1(filename: pansichar): double; stdcall;
procedure GetLastWriteTime2(filename: pansichar; var DT: TDateTimeDLL); stdcall;


exports
  B_and, B_or, B_xor,
  Color2MIColor,
  Currency,
  GetTickCount,
  MD5,
  MeasureUnit,
  Mkdir,
  Random, RandomRange, Randomize,
  sleep,
  utf8len,
  FileSize,
  GetLastWriteTime1,GetLastWriteTime2;


implementation

uses
  MD5,
  registry,
  IOUtils,
  windows,
  dateutils,
  sysutils;

function B_and(a,b: integer): integer;
begin
  result:= a and b;
end;

function B_or(a,b: integer): integer;
begin
  result:= a or b;
end;

function B_xor(a,b: integer): integer;
begin
  result:= a xor b;
end;

// to swap between MapInfo color and delphi/KML/windows color
function Color2MIColor(A: integer): integer;
begin
  result:= (A and $0000FF) shl 16 +
           (A and $00FF00)        +
           (A and $FF0000) shr 16;
end;

function Currency: pansichar;
var
  Reg: TRegistry;
  s: ansistring;
begin
  result:= '';
  Reg:= TRegistry.Create;
  try
    Reg.RootKey:= HKEY_CURRENT_USER;
    if Reg.OpenKeyReadOnly('\Control Panel\International') then
    begin
      s:= Reg.ReadString('sCurrency');
      result:= pansichar(s);
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

function GetTickCount: int64;
begin
  result:= windows.gettickcount;
end;

function MD5(filename: pansichar): pansichar;
var
  md5: TMD5;
  tmpA: ansistring;
begin
  MD5:= TMD5.create;
  try
    tmpA:= MD5.GetHash(filename);
  finally
    MD5.Free;
  end;
  result:= pansichar(tmpA);
end;

// 0: Metric
// 1: Imperial
function MeasureUnit: smallint;
var
  Reg: TRegistry;
begin
  result:= 0;  // default is km or metric
  Reg:= TRegistry.Create;
  try
    Reg.RootKey:= HKEY_CURRENT_USER;
    if Reg.OpenKeyReadOnly('\Control Panel\International') then
    begin
      result:= strtoint(Reg.ReadString('iMeasure'));
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
end;

procedure Mkdir(foldername: pansichar);
var
  s: string;
begin
  s:= foldername;
  system.mkdir(s);
end;

function Random: double;
begin
  result:= system.random;
end;

function RandomRange(a: integer): integer;
begin
  result:= system.random(a);
end;

procedure Randomize;
begin
  randomize;
end;

procedure sleep(a: integer);
begin
  sysutils.sleep(a);
end;

function utf8len(s: pansichar): integer;
var
  a: ansistring;
  u: utf8string;
begin
  a:= s;
  u:= a;
  result:= length(u);
end;

function FileSize(Filename: pansichar): Int64;
var
  s: string;
  info: TWin32FileAttributeData;
begin
  result := -1;
  s:= filename;
  if not GetFileAttributesEx(PWideChar(s), GetFileExInfoStandard, @info) then exit;
  result := Int64(info.nFileSizeLow) or Int64(info.nFileSizeHigh shl 32);
end;

function GetLastWriteTime1(filename: pansichar): double;
begin
  result:= double(TFile.GetLastWriteTime(filename));
end;

procedure GetLastWriteTime2(filename: pansichar; var DT: TDateTimeDLL);
var
  year, month, day, hour, min, sec, msec: word;
  datetime: TDateTime;
begin
  datetime:= TFile.GetLastWriteTime(filename);
  DecodeDateTime(datetime,year,month,day,hour,min,sec,msec);
  DT.year:= year;
  DT.month:= month;
  DT.day:= day;
  DT.hour:= hour;
  DT.min:= min;
  DT.sec:= sec;
  DT.msec:= msec;
end;

end.
